# MACSMine

## Description

**MACSMine - Overview**

A nearly 3D representation of the age-old minesweeper game.

Play as the main character trying to avoid the dangerous mines from blowing it up to pieces, as the numbers form a helpful pattern to guide you to victory. Survival is in your hands. Good luck!

## Background Information

This student group project, as part of Game Programming course in NTNU university, was meant to educate us in designing and building games from scratch. The lectures on various topics like game optimization, game audio, game design and others, along with knowledge of C# language and UNITY helped us with this experience. Based on the duration of course, I can safely say, the end product has been quite satisfying.

## Documentation

Documentation (including gameprog.md document) can be found above.

## Getting Started

### Prerequisities

The game was build and tested using Unity version 2020.3.22f1.

### Execution

The built version of the game has been provided above.

## Gameplay

The player controls the character which goes over a field of various tiles, which could contain a mine or a number representing the number of mines surround it. The objective is to uncover all the tiles without stepping over any mines, resulting in an explosion. This is a short explanation of the game, but for more detailed walkthrough, check out the gameplay video.

### Controls

| Action | Button | Description |
| ------ | ------ | ------ |
| Move Left | Left Arrow Key | Moving to the Left |
| Move Right | Right Arrow Key | Moving to the Right |
| Move Up | Up Arrow Key | Moving Upwards |
| Move Down | Down Arrow Key | Moving Downwards |
| Jumping | Space Key | Jumping Feature |
| Mark Mine - up | Numpad 8 | Marking the tile for the current location in the Up direction |
| Mark Mine - left | Numpad 4 | Marking the tile for the current location in the Left direction |
| Mark Mine - right | Numpad 6 | Marking the tile for the current location in the Right direction |
| Mark Mine - down | Numpad 2 | Marking the tile for the current location in the Down direction |
| Mark Mine - bottom left | Numpad 1 | Marking the tile for the current location in the Bottom Left direction |
| Mark Mine - bottom right | Numpad 3 | Marking the tile for the current location in the Bottom Right direction |
| Mark Mine - top left | Numpad 7 | Marking the tile for the current location in the Top Left direction |
| Mark Mine - top right | Numpad 9 | Marking the tile for the current location in the Top Right direction |

## Authors and Contributors

**Developers:**

* Lama Amro
* Suraj De

Thank you to our teachers for helping out during the course.

## License

This is intended to be an educational project and not a commercially licensed game. All the audio are from Unity's asset store, requiring no license.






