using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GridManager : MonoBehaviour
{
    [SerializeField]
    private int rows = 10;
    [SerializeField]
    private int cols = 10;
    [SerializeField]
    private float tileSize = 1;

    public GameObject[,] grid = new GameObject[10,10];
    // Start is called before the first frame update

    public int[] locatons = new int[100];
    public GameObject grid1;
    private markMineEasy markmine1;
    public int countcapsChain = 0;
    
    void Start()
    {
        GenerateGrid();
        //GeneralGridding();
    }

    //Awake function to connect GridManager to MarkMine in easy mode
    void Awake() {
        markmine1 = GameObject.FindObjectOfType<markMineEasy> ();
    }

    //Function to generate the grid using the resourced prefabs
    private void GenerateGrid()
    {
        int onedimleng = rows * cols;
        int zeroTileloc = 0;

        var rand = new System.Random();
        List<int> listNumbers = new List<int>();
		int number;
		for (int mineloop = 0; mineloop < 20; mineloop++)
		{
		    do {
			    number = rand.Next(0, onedimleng);
		    } 
            while (listNumbers.Contains(number) || (number % rows == 0));
            listNumbers.Add(number);
		}


        //List of prefabs to be used in the code
        GameObject TileZero = (GameObject)Instantiate(Resources.Load("TileZero"));
        GameObject TileOne = (GameObject)Instantiate(Resources.Load("TileOne"));
        GameObject TileTwo = (GameObject)Instantiate(Resources.Load("TileTwo"));
        GameObject TileThree = (GameObject)Instantiate(Resources.Load("TileThree"));
        GameObject TileFour = (GameObject)Instantiate(Resources.Load("TileFour"));
        GameObject TileFive = (GameObject)Instantiate(Resources.Load("TileFive"));
        GameObject TileSix = (GameObject)Instantiate(Resources.Load("TileSix"));
        GameObject TileSeven = (GameObject)Instantiate(Resources.Load("TileSeven"));
        GameObject TileEight = (GameObject)Instantiate(Resources.Load("TileEight"));
        GameObject TileMine = (GameObject)Instantiate(Resources.Load("TileMine"));
        GameObject Platform = (GameObject)Instantiate(Resources.Load("platformBase"));
        GameObject charTer = (GameObject)Instantiate(Resources.Load("Character"));
        GameObject baseB = (GameObject)Instantiate(Resources.Load("BaseBoard"));

        GameObject platF = (GameObject)Instantiate(Platform,transform);
        platF.transform.position = new Vector3(-2, 0, -2);
        GameObject charT = (GameObject)Instantiate(charTer,transform);
        charT.transform.position = new Vector3(-2, 2, (float)-2.5);
        GameObject baseBd = (GameObject)Instantiate(baseB,transform);
        baseBd.transform.position = new Vector3(-2, 0, (float)-2);

        //Generation of the board starts.
        for (int board = 0; board < onedimleng; board++)
        {
            int row = (board / rows);
            int col = (board % cols);

            int n = rows;
            int mineCount = 0;

            float posX = col * tileSize;
            float posY = 0;
            float posZ = row * -tileSize;

            if(board % n == 0)
            {
                if ((board - n >= 0) && (board - n < onedimleng) && listNumbers.Contains(board - n)) 
                {
                    mineCount = mineCount + 1;
                }
                if ((board - n + 1 >= 0) && (board - n + 1 < onedimleng) && listNumbers.Contains(board - n + 1)) 
                {
                    mineCount = mineCount + 1;
                }
                if ((board + 1 >= 0) && (board + 1 < onedimleng) && listNumbers.Contains(board + 1)) 
                {
                    mineCount = mineCount + 1;
                }
                if ((board + n >= 0) && (board + n < onedimleng) && listNumbers.Contains(board + n)) 
                {
                    mineCount = mineCount + 1;
                }
                if ((board + n + 1 >= 0) && (board + n + 1 < onedimleng) && listNumbers.Contains(board + n + 1)) 
                {
                    mineCount = mineCount + 1;
                }
            }
            else
                if ((board + 1) % n == 0)
                {
                    if ((board - n - 1 >= 0) && (board - n - 1 < onedimleng) && listNumbers.Contains(board - n - 1)) 
                    {
                        mineCount = mineCount + 1;
                    }
                    if ((board - n >= 0) && (board - n < onedimleng) && listNumbers.Contains(board - n)) 
                    {
                        mineCount = mineCount + 1;
                    }
                    if ((board - 1 >= 0) && (board - 1 < onedimleng) && listNumbers.Contains(board - 1))
                    {
                        mineCount = mineCount + 1;
                    }
                    if ((board + n - 1 >= 0) && (board + n - 1 < onedimleng) && listNumbers.Contains(board + n - 1))
                    {
                        mineCount = mineCount + 1;
                    }
                    if ((board + n >= 0) && (board + n < onedimleng) && listNumbers.Contains(board + n)) 
                    {
                        mineCount = mineCount + 1;
                    }
                }
                else
                    if (( board % n != 0) && ((board + 1) % n != 0))
                    {
                        if ((board - n - 1 >= 0) && (board - n - 1 < onedimleng) && listNumbers.Contains(board - n - 1))
                        {
                            mineCount = mineCount + 1;
                        }
                        if ((board - n >= 0) && (board - n < onedimleng) && listNumbers.Contains(board - n)) 
                        {
                            mineCount = mineCount + 1;
                        }
                        if ((board - n + 1 >= 0) && (board - n + 1 < onedimleng) && listNumbers.Contains(board - n + 1)) 
                        {
                            mineCount = mineCount + 1;
                        }
                        if ((board - 1 >= 0) && (board - 1 < onedimleng) && listNumbers.Contains(board - 1)) 
                        {
                            mineCount = mineCount + 1;
                        }
                        if ((board + 1 >= 0) && (board + 1 < onedimleng) && listNumbers.Contains(board + 1)) 
                        {
                            mineCount = mineCount + 1;
                        }
                        if ((board + n - 1 >= 0) && (board + n - 1 < onedimleng) && listNumbers.Contains(board + n - 1)) 
                        {
                            mineCount = mineCount + 1;
                        }
                        if ((board + n >= 0) && (board + n < onedimleng) && listNumbers.Contains(board + n)) 
                        {
                            mineCount = mineCount + 1;
                        }
                        if ((board + n + 1 >= 0) && (board + n + 1 < onedimleng) && listNumbers.Contains(board + n + 1)) 
                        {
                            mineCount = mineCount + 1;
                        }
                    }
            if(listNumbers.Contains(board))
            {
                GameObject tilemine = (GameObject)Instantiate(TileMine, transform);
                tilemine.transform.position = new Vector3(posX, posY, posZ);
            }
            else
            {
                switch (mineCount)
                {
                    case 0:
                        GameObject tile0 = (GameObject)Instantiate(TileZero, transform);
                        tile0.transform.position = new Vector3(posX, posY, posZ);
                        locatons[zeroTileloc] = board;
                        zeroTileloc = zeroTileloc + 1;
                        break;

                    case 1:
                        GameObject tile1 = (GameObject)Instantiate(TileOne, transform);
                        tile1.transform.position = new Vector3(posX, posY, posZ);
                        break;

                    case 2:
                        GameObject tile2 = (GameObject)Instantiate(TileTwo, transform);
                        tile2.transform.position = new Vector3(posX, posY, posZ);
                        break;

                    case 3:
                        GameObject tile3 = (GameObject)Instantiate(TileThree, transform);
                        tile3.transform.position = new Vector3(posX, posY, posZ);
                        break;

                    case 4:
                        GameObject tile4 = (GameObject)Instantiate(TileFour, transform);
                        tile4.transform.position = new Vector3(posX, posY, posZ);
                        break;

                    case 5:
                        GameObject tile5 = (GameObject)Instantiate(TileFive, transform);
                        tile5.transform.position = new Vector3(posX, posY, posZ);
                        break;

                    case 6:
                        GameObject tile6 = (GameObject)Instantiate(TileSix, transform);
                        tile6.transform.position = new Vector3(posX, posY, posZ);
                        break;

                    case 7:
                        GameObject tile7 = (GameObject)Instantiate(TileSeven, transform);
                        tile7.transform.position = new Vector3(posX, posY, posZ);
                        break;

                    case 8:
                        GameObject tile8 = (GameObject)Instantiate(TileEight, transform);
                        tile8.transform.position = new Vector3(posX, posY, posZ);
                        break;

                }
                
            }

            grid[row,col] = (GameObject)Instantiate(Resources.Load("Cap"),
                new Vector3(posX, (posY + (float)(0.61)), posZ),Quaternion.identity);

        }
        //Destruction of created gameobjects from prefabs
        Destroy(charTer);
        Destroy(baseB);
        Destroy(Platform);
        Destroy(TileMine);
        Destroy(TileOne);
        Destroy(TileTwo);
        Destroy(TileThree);
        Destroy(TileFour);
        Destroy(TileFive);
        Destroy(TileSix);
        Destroy(TileSeven);
        Destroy(TileEight);
        Destroy(TileZero);

    }

    
    // Update is called once per frame
    void Update()
    {   

    }

    //To create the chain opening mechanism upto one level
    public void UpdateGrid(GameObject gridcheck)
    {
        grid1 = gridcheck;
        int n = rows;
        int onedimleng = rows*cols;

        for(int gridloop = 0; gridloop < onedimleng; gridloop = gridloop + 1)
        {
            int row = (gridloop / rows);
            int col = (gridloop % cols);
            countcapsChain = 0;

            if(grid[row,col] == gridcheck && Array.IndexOf(locatons,gridloop) != -1)
            {
                if(gridloop % n == 0)
                {
                    if ((gridloop - n >= 0) && (gridloop - n < onedimleng)) 
                    {
                        grid[row, col+1].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                    if ((gridloop - n + 1 >= 0) && (gridloop - n + 1 < onedimleng)) 
                    {
                        grid[row+1, col+1].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                    if ((gridloop + 1 >= 0) && (gridloop + 1 < onedimleng)) 
                    {
                        grid[row+1, col].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                    if ((gridloop + n >= 0) && (gridloop + n < onedimleng)) 
                    {
                        grid[row, col-1].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                    if ((gridloop + n + 1 >= 0) && (gridloop + n + 1 < onedimleng)) 
                    {
                        grid[row+1, col-1].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                }
                if ((gridloop + 1) % n == 0)
                {
                    if ((gridloop - n - 1 >= 0) && (gridloop - n - 1 < onedimleng)) 
                    {
                        grid[row-1, col+1].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                    if ((gridloop - n >= 0) && (gridloop - n < onedimleng)) 
                    {
                        grid[row, col+1].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                    if ((gridloop - 1 >= 0) && (gridloop - 1 < onedimleng)) 
                    {
                        grid[row-1, col].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                    if ((gridloop + n - 1 >= 0) && (gridloop + n - 1 < onedimleng)) 
                    {
                        grid[row-1, col-1].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                    if ((gridloop + n >= 0) && (gridloop + n < onedimleng)) 
                    {
                        grid[row, col-1].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                }
                if (( gridloop % n != 0) && ((gridloop + 1) % n != 0))
                {
                    if ((gridloop - n - 1 >= 0) && (gridloop - n - 1 < onedimleng)) 
                    {
                        grid[row-1, col+1].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                    if ((gridloop - n >= 0) && (gridloop - n < onedimleng)) 
                    {
                        grid[row, col+1].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                    if ((gridloop - n + 1 >= 0) && (gridloop - n + 1 < onedimleng)) 
                    {
                        grid[row+1, col+1].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                    if ((gridloop - 1 >= 0) && (gridloop - 1 < onedimleng)) 
                    {
                        grid[row-1, col].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                    if ((gridloop + 1 >= 0) && (gridloop + 1 < onedimleng)) 
                    {
                        grid[row+1, col].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                    if ((gridloop + n - 1 >= 0) && (gridloop + n - 1 < onedimleng)) 
                    {
                        grid[row-1, col-1].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                    if ((gridloop + n >= 0) && (gridloop + n < onedimleng)) 
                    {
                        grid[row, col-1].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                    if ((gridloop + n + 1 >= 0) && (gridloop + n + 1 < onedimleng)) 
                    {
                        grid[row+1, col-1].SetActive(false);
                        countcapsChain = countcapsChain + 1;
                    }
                }

                markmine1.chaincapCount(countcapsChain);
            }
        }
    }
}
